/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.web;

import javax.servlet.http.HttpServletRequest;

import com.mysema.commons.lang.URLEncoder;

/**
 * URLBuilder provides
 *
 * @author tiwe
 * @version $Id$
 */
public class URLBuilder {

    private StringBuilder builder = new StringBuilder();;

    private boolean paramsGiven = false;

    private boolean encodeSlashes = false;

    public URLBuilder(HttpServletRequest req){
        this(req.getContextPath(), false);        
    }

    public URLBuilder(String str){
        this(str, false);    	
    }

    public URLBuilder(HttpServletRequest req, boolean encodeSlashes){
        this(req.getContextPath(), encodeSlashes);
    }

    public URLBuilder(String str, boolean encodeSlashes){
        builder.append(str);       
        this.encodeSlashes = encodeSlashes;
    }    

    public URLBuilder add(String... strings){    	
        for (String str : strings){
            if (builder.charAt(builder.length()-1) != '/' && str.charAt(0) != '/'){
                builder.append('/');
            }
            if (encodeSlashes) {
                builder.append(URLEncoder.encodeParam(str));
            }
            else {
                builder.append(URLEncoder.encodeURL(str));
            }
        }    	
        return this;
    }

    public URLBuilder param(String key, String value){
        builder.append(paramsGiven ? "&" : "?");
        builder.append(key).append("=").append(URLEncoder.encodeParam(value));		
        paramsGiven = true;
        return this;
    }

    public String toString(){
        return builder.toString();
    }

}
